<?php
declare( strict_types=1 );
/**
 * Plugin Name: SPOT® – Permanent Transaction Control
 * Plugin URI: https://wordpress.org/plugins/eclear-spot
 * Description: With SPOT® you always keep control over your turnover, sales and tax data. Real-time alerts reliably notify you of cross-border compliance requirements.
 * Product: Eclear Spot
 * Version: 1.0.8
 * Tested up to: 6.1.1
 * Requires PHP: 7.2.0
 * Author: iLabs LTD
 * Author URI: iLabs.dev
 * Text Domain: eclear-spot
 * Domain Path: /lang/
 *
 * Copyright 2022 iLabs LTD
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly


require_once __DIR__ . '/vendor/autoload.php';
require_once __DIR__ . '/vendor/ilabs/isolated-guzzlehttp/vendor/autoload.php';

function eclear_spot(): Ilabs\Eclear_Spot\Plugin {
	return new Ilabs\Eclear_Spot\Plugin();
}

$config = [
	'__FILE__'    => __FILE__,
	'slug'        => 'eclear_spot',
	'lang_dir'    => 'lang',
	'text_domain' => 'eclear-spot',
	'version'     => '1.0.8',
];

eclear_spot()->execute( $config );
