<?php

namespace Ilabs\Eclear_Spot;

use Exception;

class Hooks {

	public function init() {
		$this->add_plugin_action_links();
		$this->add_description_to_settings_page();
	}


	private function add_description_to_settings_page() {
		add_action( 'woocommerce_after_settings_eclear_spot_general_settings', function () {
			require_once eclear_spot()->get_plugin_dir() . DIRECTORY_SEPARATOR . 'Templates' . DIRECTORY_SEPARATOR . 'desc.php';
		} );
	}


	/**
	 * @throws Exception
	 */
	private function add_plugin_action_links() {
		add_filter( 'plugin_action_links_' . eclear_spot()->get_plugin_basename() . '/' . eclear_spot()->get_plugin_basename() . '.php',
			function ( $links ) {
				$links[] = '<a href="' .
				           $this->get_settings_page() .
				           '">' . __( 'Settings', 'eclear_spot' ) . '</a>';

				return $links;
			} );
	}


	private function get_settings_page(): string {
		return admin_url() . 'admin.php?page=wc-settings&tab=eclear_spot_general_settings';
	}
}



