<?php

namespace Ilabs\Eclear_Spot\Remote\Dto;

class Data_DTO {

	/**
	 * @var string
	 */
	private $doc_id;
	/**
	 * @var string
	 */
	private $doc_category;
	/**
	 * @var string
	 */
	private $cust_no;
	/**
	 * @var string
	 */
	private $doc_no;
	/**
	 * @var string
	 */
	private $ext_order_id;
	/**
	 * @var string
	 */
	private $order_time_stamp;
	/**
	 * @var string
	 */
	private $invoice_date;
	/**
	 * @var string
	 */
	private $shipping_gdate;
	/**
	 * @var string
	 */
	private $payment_date;
	/**
	 * @var int
	 */
	private $invoice_amount;
	/**
	 * @var string
	 */
	private $delivery_address_zip;
	/**
	 * @var string
	 */
	private $delivery_address_country;
	/**
	 * @var string
	 */
	private $invoice_address_zip;
	/**
	 * @var string
	 */
	private $invoice_address_country;
	/**
	 * @var string
	 */
	private $shipped_from_country;
	/**
	 * @var string
	 */
	private $payment;
	/**
	 * @var string
	 */
	private $platform;
	/**
	 * @var string
	 */
	private $consumer_vat_id;
	/**
	 * @var string
	 */
	private $customer_vat_id;
	/**
	 * @var string
	 */
	private $type;
	/**
	 * @var string
	 */
	private $shipping;
	/**
	 * @var string
	 */
	private $currency;
	/**
	 * @var float
	 */
	private $exchange_rate;
	/**
	 * @var Product_DTO[]
	 */
	private $array_items;


	public function to_array(): array {
		return [
			"DocID"                  => $this->doc_id,
			"DocCategory"            => $this->doc_category,
			"CustNo"                 => $this->cust_no,
			"DocNo"                  => $this->doc_no,
			"ExtOrderID"             => $this->ext_order_id,
			"OrderTimeStamp"         => $this->order_time_stamp,
			"InvoiceDate"            => $this->invoice_date,
			"ShippingDate"           => $this->shipping_gdate,
			"PaymentDate"            => $this->payment_date,
			"InvoiceAmount"          => $this->invoice_amount,
			"DeliveryaddressZIP"     => $this->delivery_address_zip,
			"DeliveryaddressCountry" => $this->delivery_address_country,
			"InvoiceAddressZIP"      => $this->invoice_address_zip,
			"InvoiceAddressCountry"  => $this->invoice_address_country,
			"ShippedfromCountry"     => $this->shipped_from_country,
			"Payment"                => $this->payment,
			"Platform"               => $this->platform,
			"ConsumerVatID"          => $this->consumer_vat_id,
			"CustomerVatID"          => $this->customer_vat_id,
			"Type"                   => $this->type,
			"Shipping"               => $this->shipping,
			"Currency"               => $this->currency,
			"Exchangerate"           => $this->exchange_rate,
			"ARRAY_Items"            => ( function () {
				$items = [];
				foreach ( $this->array_items as $item ) {
					$items[] = $item->to_array();
				}

				return $items;
			} )(),
		];
	}


	/**
	 * @return string
	 */
	public function get_doc_id(): string {
		return $this->doc_id;
	}

	/**
	 * @param string $doc_id
	 */
	public function set_doc_id( string $doc_id ): void {
		$this->doc_id = $doc_id;
	}

	/**
	 * @return string
	 */
	public function get_doc_category(): string {
		return $this->doc_category;
	}

	/**
	 * @param string $doc_category
	 */
	public function set_doc_category( string $doc_category ): void {
		$this->doc_category = $doc_category;
	}

	/**
	 * @return string
	 */
	public function get_cust_no(): string {
		return $this->cust_no;
	}

	/**
	 * @param string $cust_no
	 */
	public function set_cust_no( string $cust_no ): void {
		$this->cust_no = $cust_no;
	}

	/**
	 * @return string
	 */
	public function get_doc_no(): string {
		return $this->doc_no;
	}

	/**
	 * @param string $doc_no
	 */
	public function set_doc_no( string $doc_no ): void {
		$this->doc_no = $doc_no;
	}

	/**
	 * @return string
	 */
	public function get_ext_order_id(): string {
		return $this->ext_order_id;
	}

	/**
	 * @param string $ext_order_id
	 */
	public function set_ext_order_id( string $ext_order_id ): void {
		$this->ext_order_id = $ext_order_id;
	}

	/**
	 * @return string
	 */
	public function get_order_time_stamp(): string {
		return $this->order_time_stamp;
	}

	/**
	 * @param string $order_time_stamp
	 */
	public function set_order_time_stamp( string $order_time_stamp ): void {
		$this->order_time_stamp = $order_time_stamp;
	}

	/**
	 * @return string
	 */
	public function get_invoice_date(): string {
		return $this->invoice_date;
	}

	/**
	 * @param string $invoice_date
	 */
	public function set_invoice_date( string $invoice_date ): void {
		$this->invoice_date = $invoice_date;
	}

	/**
	 * @return string
	 */
	public function get_shipping_gdate(): string {
		return $this->shipping_gdate;
	}

	/**
	 * @param string $shipping_gdate
	 */
	public function set_shipping_gdate( string $shipping_gdate ): void {
		$this->shipping_gdate = $shipping_gdate;
	}

	/**
	 * @return string
	 */
	public function get_payment_date(): string {
		return $this->payment_date;
	}

	/**
	 * @param string $payment_date
	 */
	public function set_payment_date( string $payment_date ): void {
		$this->payment_date = $payment_date;
	}

	/**
	 * @return int
	 */
	public function get_invoice_amount(): int {
		return $this->invoice_amount;
	}

	/**
	 * @param int $invoice_amount
	 */
	public function set_invoice_amount( int $invoice_amount ): void {
		$this->invoice_amount = $invoice_amount;
	}

	/**
	 * @return string
	 */
	public function get_delivery_address_zip(): string {
		return $this->delivery_address_zip;
	}

	/**
	 * @param string $delivery_address_zip
	 */
	public function set_delivery_address_zip( string $delivery_address_zip ): void {
		$this->delivery_address_zip = $delivery_address_zip;
	}

	/**
	 * @return string
	 */
	public function get_delivery_address_country(): string {
		return $this->delivery_address_country;
	}

	/**
	 * @param string $delivery_address_country
	 */
	public function set_delivery_address_country( string $delivery_address_country ): void {
		$this->delivery_address_country = $delivery_address_country;
	}

	/**
	 * @return string
	 */
	public function get_invoice_address_zip(): string {
		return $this->invoice_address_zip;
	}

	/**
	 * @param string $invoice_address_zip
	 */
	public function set_invoice_address_zip( string $invoice_address_zip ): void {
		$this->invoice_address_zip = $invoice_address_zip;
	}

	/**
	 * @return string
	 */
	public function get_invoice_address_country(): string {
		return $this->invoice_address_country;
	}

	/**
	 * @param string $invoice_address_country
	 */
	public function set_invoice_address_country( string $invoice_address_country ): void {
		$this->invoice_address_country = $invoice_address_country;
	}

	/**
	 * @return string
	 */
	public function get_shipped_from_country(): string {
		return $this->shipped_from_country;
	}

	/**
	 * @param string $shipped_from_country
	 */
	public function set_shipped_from_country( string $shipped_from_country ): void {
		$this->shipped_from_country = $shipped_from_country;
	}

	/**
	 * @return string
	 */
	public function get_payment(): string {
		return $this->payment;
	}

	/**
	 * @param string $payment
	 */
	public function set_payment( string $payment ): void {
		$this->payment = $payment;
	}

	/**
	 * @return string
	 */
	public function get_platform(): string {
		return $this->platform;
	}

	/**
	 * @param string $platform
	 */
	public function set_platform( string $platform ): void {
		$this->platform = $platform;
	}

	/**
	 * @return string
	 */
	public function get_consumer_vat_id(): string {
		return $this->consumer_vat_id;
	}

	/**
	 * @param string $consumer_vat_id
	 */
	public function set_consumer_vat_id( string $consumer_vat_id ): void {
		$this->consumer_vat_id = $consumer_vat_id;
	}

	/**
	 * @return string
	 */
	public function get_customer_vat_id(): string {
		return $this->customer_vat_id;
	}

	/**
	 * @param string $customer_vat_id
	 */
	public function set_customer_vat_id( string $customer_vat_id ): void {
		$this->customer_vat_id = $customer_vat_id;
	}

	/**
	 * @return string
	 */
	public function get_type(): string {
		return $this->type;
	}

	/**
	 * @param string $type
	 */
	public function set_type( string $type ): void {
		$this->type = $type;
	}

	/**
	 * @return string
	 */
	public function get_shipping(): string {
		return $this->shipping;
	}

	/**
	 * @param string $shipping
	 */
	public function set_shipping( string $shipping ): void {
		$this->shipping = $shipping;
	}

	/**
	 * @return string
	 */
	public function get_currency(): string {
		return $this->currency;
	}

	/**
	 * @param string $currency
	 */
	public function set_currency( string $currency ): void {
		$this->currency = $currency;
	}

	/**
	 * @return float
	 */
	public function get_exchange_rate(): float {
		return $this->exchange_rate;
	}

	/**
	 * @param float $exchange_rate
	 */
	public function set_exchange_rate( float $exchange_rate ): void {
		$this->exchange_rate = $exchange_rate;
	}

	/**
	 * @return array
	 */
	public function get_array_items(): array {
		return $this->array_items;
	}

	/**
	 * @param array $array_items
	 */
	public function set_array_items( array $array_items ): void {
		$this->array_items = $array_items;
	}
}
