<?php

namespace Ilabs\Eclear_Spot\Service;

use Ilabs\Eclear_Spot\Model\Spot_File;
use WP_Filesystem_Direct;

class Spot_Filesystem {

	public function create( string $payload_json ): Spot_File {
		$uploads_dir = eclear_spot()->get_uploads_dir();

		wp_mkdir_p( $uploads_dir . DIRECTORY_SEPARATOR . 'spot_json' );

		$target_directory = $uploads_dir . DIRECTORY_SEPARATOR . 'spot_json';

		require_once( ABSPATH . 'wp-admin/includes/file.php' );
		global $wp_filesystem;
		if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base' ) ) {
			$creds = request_filesystem_credentials( site_url() );
			wp_filesystem( $creds );
		}

		$file_name = sanitize_file_name( gmdate( 'Y-m-d h:i:s', time() ) . '.json' );

		$success = $wp_filesystem->put_contents(
			$target_directory . DIRECTORY_SEPARATOR . $file_name,
			$payload_json,
			FS_CHMOD_FILE // predefined mode settings for WP files
		);

		/*if ( ! $success ) {
			error_log( "Writing to file \"" . $filePathStr . "\" failed." );
		} else {
			error_log( "Writing to file \"" . $filePathStr . "\" succeeded." );
		}*/

		$file = new Spot_File();
		$file->set_full_path( $target_directory . DIRECTORY_SEPARATOR . $file_name );

		return $file;
	}

	public function remove_file( Spot_File $file ) {
		WP_Filesystem_Direct::delete( $file->get_full_path() );
	}

    public function put_old_orders_ids_to_file( string $json ): void {
        $uploads_dir = eclear_spot()->get_uploads_dir();

        wp_mkdir_p( $uploads_dir . DIRECTORY_SEPARATOR . 'spot_json' );

        $target_directory = $uploads_dir . DIRECTORY_SEPARATOR . 'spot_json';

        require_once( ABSPATH . 'wp-admin/includes/file.php' );
        global $wp_filesystem;
        if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base' ) ) {
            $creds = request_filesystem_credentials( site_url() );
            wp_filesystem( $creds );
        }

        $file_name = 'old_orders.json';

        $success = $wp_filesystem->put_contents(
            $target_directory . DIRECTORY_SEPARATOR . $file_name,
            $json,
            FS_CHMOD_FILE // predefined mode settings for WP files
        );

        $file = new Spot_File();
        $file->set_full_path( $target_directory . DIRECTORY_SEPARATOR . $file_name );
    }
}
